function Pedido_Cotacao_Service(restEngine, localStorageEngine, General) {
    
    this.permissaoIncluirProduto = function () {
        return restEngine.post('product#/crud/permissaoIncluirProd', {
            "requestType": "FilterData",
            "filter": [
                {   "name": "P_CDFORNECED",		"operator": "=",	"value": getLocalVar('CDFORNECED')   },
                {   "name": "NRORG",            "operator": "=",    "value": getLocalVar('NRORGTRAB')    }
            ]
        });
    };
    
    this.retornaRegiao = function(cdfilial, nrpedidocol) {
		return restEngine.post('product#/crud/regiaoCotacao', {
			"requestType": "FilterData",
			"filter": [
				 { 	"name": "P_CDFILIAL", 		"operator": "=",	"value":  cdfilial		},
				 { 	"name": "P_NRPEDIDOCOL", 	"operator": "=", 	"value":  nrpedidocol	}
			]
		});
	};
	
	this.retornaProdutoCotacao = function(cdforneced, cdfilial, nrpedidocol) {

		return restEngine.post('/produtoCotacao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFORNECED",
				 	"operator": "=",
				 	"value":  cdforneced
				 },
				 {
				 	"name": "P_CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "P_NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};
	
	this.parasupri = function(cdfilial) {
		return restEngine.post('product#/crud/parasupri', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value":  cdfilial
				}
			]
		});
	};
	
	this.incluirPrmarcpedcol = function(cdfilial, cdproduto, nrpeddocol, cdmarca) {
		var produto = [];
		var prod = {
			CDFILIAL:        cdfilial,
			CDMARCA:		 cdmarca,
			CDPRODUTO:		 cdproduto,
			DSOBSRENEGOCIA:  '',
			IDITPEDPRIONEG:  'N',
			NRPEDIDOCOL:	 nrpeddocol,
			QTDISPPRODMARC:  '',
			VRPRECUNIPRMARC: null,
			VRULTPRECPRMARC: '',
			IDPRODINCLFOR:   'S',
			__is_new : true
		};
		produto.push(prod);
		
		return restEngine.post('product#/savePrmarcpedcol', {
			"requestType": "DataSet",
			"dataset": produto
		});
	};
	
	this.inserirItempedcol = function (cdfilial, nrpedidocol, cdproduto, cdmarca) {
		var produto = [];
		var prod = {
			P_CDFILIAL:    cdfilial,
            P_NRPEDCOLETA: nrpedidocol,
            P_CDPRODUTO:   cdproduto,
            P_CDMARCA:     cdmarca
		};
		produto.push(prod);
       	return restEngine.post("product#/inserirItempedcol", {
          	"requestType": "Row",
			"row": produto
		});
    };
    
    this.validaItemZero = function(cdfilial, nrpedidocol) {
		return restEngine.post('product#/crud/itemZero', {
			"requestType": "FilterData",
			"filter": [
				 { 	"name": "CDFILIAL", 	"operator": "=", 	"value":  cdfilial		},
				 { 	"name": "NRPEDIDOCOL", 	"operator": "=",	"value":  nrpedidocol	}
			]
		});
	};
	
	this.aceitaPedidoCotacao = function(dados, idconsiste) {
        return restEngine.post('product#/aceitaPedidoCotacao', {
            "requestType": "Row",
            "row": {
				"CDFILIAL": 		 dados.CDFILIAL,
                "NRPEDIDOCOL":		 dados.NRPEDIDOCOL,
                "IDCONSISTE":		 idconsiste,
                "NMRAZSOCFORN": 	 dados.NMRAZSOCFORN,
                "EMAIL_RESPONSAVEL": dados.EMAIL,
                "EMAIL_LOGADO": 	 getLocalVar("EMAIL"),
                "NMUSUARIOECO":      (getLocalVar('NMUSUARIOECO') != '' && getLocalVar('NMUSUARIOECO') != null) ? getLocalVar('NMUSUARIOECO') : getLocalVar('EMAIL'),
                "DATA":				 moment().format('DD/MM/YYYY hh:mm')
            }
        });
    };
    
    this.recusarCotacao = function(dados, idsitupedcoleta) {
		return restEngine.post('product#/recusaPedidoCotacao', {
            "requestType": "Row",
			"row": {
                "CDFILIAL":          dados.CDFILIAL,
                "NRPEDIDOCOL":       dados.NRPEDIDOCOL,
                "IDSITUPEDCOLETA":   idsitupedcoleta, 
                "NMRAZSOCFORN": 	 dados.NMRAZSOCFORN,
                "EMAIL_RESPONSAVEL": dados.EMAIL,
                "EMAIL_LOGADO": 	 getLocalVar("EMAIL"),
                "NMUSUARIOECO":      (getLocalVar('NMUSUARIOECO') != '' && getLocalVar('NMUSUARIOECO') != null) ? getLocalVar('NMUSUARIOECO') : getLocalVar('EMAIL'),
                "DATA":				 moment().format('DD/MM/YYYY hh:mm'),
                "changed": true,
				"__is_new": false
            }
        });
	};
	
	this.registrarAcesso = function(row){
        
        var parametroRestEngine = {
            "requestType" : "Row",
            "row" : row
        };
        
        return restEngine.post('product#/registrarAcesso', parametroRestEngine)
            .then(function(response){
            }.bind(this))
            .catch(function(error){
                throw error;
            }
        );
  
	};
	
	this.executarExportacao = function(dataSet) {
        
        var parametroRestEngine = {
            "requestType" : "DataSet",
            "dataset" : dataSet
        };
        
        return restEngine.post('product#/pedidoExportacao', parametroRestEngine)
            .then(function(response){
                return response;
            }.bind(this))
            .catch(function(error){
                throw error;
            }
        );
    
	};
	
	this.atualizarFrete = function(row) {
        
        var parametroRestEngine = {
            "requestType" : "Row",
            "row" : row
        };
        
        return restEngine.post('product#/valorFrete', parametroRestEngine)
            .then(function(response){
            }.bind(this))
            .catch(function(error){
                throw error;
            }
        );
   
	};
	
	this.checarFornecedor = function(row) {
		
		var parametroRestEngine = {
            "requestType" : "Row",
            "row" : row
        };
        
        return restEngine.post('product#/checarFornecedor', parametroRestEngine)
            .then(function(response){
                return response;
            }.bind(this))
            .catch(function(error){
                throw error;
            }
        );
	};
	
	this.salvarComentario = function(row, info) {
		row.OP_RESPONSAVEL    = info.COD_RESPONSAVEL;
        row.NM_RESPONSAVEL    = info.NM_RESPONSAVEL;
        row.EMAIL_RESPONSAVEL = info.EMAIL;
        row.EMAIL_LOGADO	  = getLocalVar("EMAIL");
        row.NMUSUARIOECO      = (getLocalVar('NMUSUARIOECO') != '' && getLocalVar('NMUSUARIOECO') != null) ? getLocalVar('NMUSUARIOECO') : getLocalVar('EMAIL');
        row.NRPEDIDOCOL 	  = info.NRPEDIDOCOL;
        row.CDFILIAL    	  = info.CDFILIAL;
        return restEngine.post("product#/comentpedcol/save", {
          	"requestType": "Row",
			"row": row
		});
	};
	
	this.verifyParamTermoAceite = function(currentRow) {
        return restEngine.post("product#/verifyParamTermoAceite", {
          	"requestType": "Row",
			"row": currentRow
		});
	};
	
	this.saveCollectData = function(params) {
        return restEngine.post('product#/saveCollectedData', {
            "requestType": "Row",
            "row": params
        });
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Pedido_Cotacao_Service', Pedido_Cotacao_Service);
});